Index: main/branches/64_bit_Greenstone/greenstone3/Client-side Overview.txt
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/Client-side Overview.txt	(revision 24007)
+++ main/branches/64_bit_Greenstone/greenstone3/Client-side Overview.txt	(revision 24007)
@@ -0,0 +1,14 @@
+This version of Greenstone 3 has been optimised as part of the Summer Research Scholarship I undertook. This version, however, also contains support for client-side XSLT.
+
+The main modifications include:
+* The use of Apache Commons StringUtils class for text replacement and splitting;
+* The use of StringUtils.contains over the *.text.* regular expression;
+* Plus: client-side XSLT support.
+
+Note that the XML Texts collection had to be modified in certain areas due to it using four XSL overrides in its transform directory. This may or may not be necessary depending on the XSL overrides in place for other collections. For an example of this, see the about-clientside.xsl file in the gberg collection.
+
+Steven McTainsh
+February 2011
+
+
+
Index: main/branches/64_bit_Greenstone/greenstone3/WITHOUT-JNI.sh
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/WITHOUT-JNI.sh	(revision 24007)
+++ main/branches/64_bit_Greenstone/greenstone3/WITHOUT-JNI.sh	(revision 24007)
@@ -0,0 +1,34 @@
+#!/bin/bash
+
+echo "Renaming MG and GDBM related source code to 'java..tmp' file names"
+
+pushd src/java/org/greenstone/gsdl3
+
+cd service
+echo "  Processing 'service' directory"
+
+for f in *MG*java PhindPhraseBrowse.java ; do
+  if [ -e $f ] ; then
+    echo "    $f -> $f.tmp"
+    /bin/mv $f $f.tmp
+  fi
+done
+
+cd ..
+
+
+cd util
+echo "  Processing 'util' directory"
+
+for f in *GDBM*java ; do
+  if [ -e $f ] ; then
+    echo "    $f -> $f.tmp"
+    /bin/mv $f  $f.tmp
+  fi
+done
+cd ..
+
+popd
+
+
+
Index: main/branches/64_bit_Greenstone/greenstone3/build.properties.in
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/build.properties.in	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/build.properties.in	(revision 24007)
@@ -19,4 +19,7 @@
 # uncomment if you don't want to have collection building enabled
 #disable.collection.building=true
+#
+# uncomment (and edit) if you want to control where perl is found
+#perl.path=/usr/bin
 
 ## Greenstone 3 server program options
@@ -57,8 +60,14 @@
 with.jni=true
 
+## Controls whether or not we want GLI and GEMS to be checked out and compiled
+with.gli.and.gems=true
+
 ## Control if compilation of gs2 is static or not. Used, for example, for distributions
 # Same issue as 'with.jni' for how this gets used in ant 1.7.1 and before
 #compile.static=true
 
+## Uncomment this line to enable compilation with the gnome-lib extension
+## The gnome-lib extension should be in the [gsdl3home]/ext directory
+#use.support.lib=true
 
 ## windows c++ compilation
Index: main/branches/64_bit_Greenstone/greenstone3/gs3-setup.sh
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/gs3-setup.sh	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/gs3-setup.sh	(revision 24007)
@@ -269,14 +269,16 @@
 fi
 
-if test -e ext ; then
-  for gsdl_ext in ext/* ; do
-    if [ -d $gsdl_ext ] ; then 
-      cd $gsdl_ext > /dev/null
-      if test -e setup.bash ; then 
-        source ./setup.bash 
-      fi 
-      cd ../..  
-    fi
-  done
+if test "x$gsopt_noexts" != "x1" ; then
+    if test -e ext ; then
+	for gsdl_ext in ext/* ; do
+	    if [ -d $gsdl_ext ] ; then 
+		cd $gsdl_ext > /dev/null
+		if test -e setup.bash ; then 
+		    source ./setup.bash 
+		fi 
+		cd ../..  
+	    fi
+	done
+    fi
 fi
 
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/ClientSideServlet.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/ClientSideServlet.java	(revision 24007)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/ClientSideServlet.java	(revision 24007)
@@ -0,0 +1,149 @@
+package org.greenstone.gsdl3;
+
+import org.apache.log4j.*; // Actually add logging?
+import org.apache.commons.lang3.StringUtils;
+import org.greenstone.gsdl3.util.XSLTUtil;
+import java.io.*;
+import javax.servlet.*;
+import javax.servlet.http.*;
+import org.greenstone.gsdl3.util.Dictionary;
+import java.util.Enumeration;
+
+public class ClientSideServlet extends HttpServlet {
+	
+public void init(ServletConfig config) throws ServletException {
+	super.init(config);	
+}	
+	
+public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {   
+   
+   String query_string = request.getQueryString();
+   PrintWriter w = response.getWriter();
+
+	if(query_string == null)
+		displayParamError(response);
+	
+		String[] parts = StringUtils.split(query_string, "&");
+	
+		String[] keys = null; // Array of keys to look up
+		String lang = "";
+		String interface_name = "";	
+		String command = "";	
+		String params = "";
+		
+		for(String part : parts) {		
+		
+			String[] nameval = StringUtils.split(part, '=');
+
+			if(nameval.length != 2) {
+				displayParamError(response);
+				return;
+			}			
+			
+			String name = nameval[0];
+			String value = nameval[1];
+			
+			if(name.equals("k"))
+				keys = StringUtils.split(value, ",");
+			else if(name.equals("l"))
+				lang = value;
+			else if(name.equals("i"))
+				interface_name = value;
+			else if(name.equals("c"))
+				// Alternative commands
+				command = value;
+			else if(name.equals("p"))
+				params = value;
+		}
+		
+		if(keys == null && command.equals("") && params.equals("")) {
+			// Not satisfiable
+			displayParamError(response);
+			return;	
+		}
+		
+		String bundle = "<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\r\n<textBundle>\r\n";
+		
+		if(!command.equals("") && !params.equals("")) {
+		
+			// Alternative commands other than dictionary lookup
+			String[] parameters = StringUtils.split(params, "|");			
+			String result = null;		
+			
+			if(command.equals("getNumberedItem") && parameters.length == 2) {
+				result = XSLTUtil.getNumberedItem(parameters[0], Integer.parseInt(parameters[1]));
+			} else if(command.equals("exists") && parameters.length == 2) {
+				result = XSLTUtil.exists(parameters[0], parameters[1]) ? "true" : "false";
+			} else if(command.equals("isImage") && parameters.length == 1) {
+				result = (XSLTUtil.isImage(parameters[0])) ? "true" : "false";	
+			}
+			
+			if(result != null) {
+				bundle += "	<method name=\"" + command + "\" parameters=\"" + params + "\" return=\"" + result + "\" />\r\n";
+			} else { displayParamError(response); return; }
+		} else {
+		
+		for(String key : keys) {
+		
+			String original_key = key;
+			String[] theParts = StringUtils.split(key, "|");
+			String[] args = null;
+			
+			if(theParts.length > 1)
+				args = StringUtils.split(theParts[1], ";");
+		
+			key = theParts[0];
+		
+			// Straight from XSLTUtils.java (src), with some modifications
+			if(key.equals("null")) {
+				bundle += "	<item key=\"" + key + "\" value=\"\" />\r\n";
+				continue;
+			}
+				
+			Dictionary dict = new Dictionary("interface_"+interface_name, lang);
+			String result = dict.get(key, args);
+			
+			if (result == null) {
+				String sep_interface_dir = interface_name + File.separatorChar + lang + File.separatorChar + "interface"; 
+				dict = new Dictionary(sep_interface_dir, lang);
+				result = dict.get(key, args);  
+			 }
+
+			if (result == null && !interface_name.equals("default")) { // not found, try the default interface
+			    dict = new Dictionary("interface_default", lang);
+			    result = dict.get(key, args);
+			}
+			    
+		    if (result == null) { // not found
+			    result = "_" + original_key + "_";
+		    } 
+
+			bundle += "	<item key=\"" + encode(original_key) + "\" value=\"" + encode(result) + "\" />\r\n";
+		} }
+		
+		bundle += "</textBundle>";
+		
+		response.setContentType("text/xml");   			
+
+		w.print(bundle);
+		w.close();
+}
+
+private String encode(String s) {
+	s = StringUtils.replace(s, "&", "&amp;");
+	s = StringUtils.replace(s, "<", "&lt;");
+	s = StringUtils.replace(s, ">", "&gt;");
+	return s;
+}
+
+private void displayParamError(HttpServletResponse response) {
+
+	try {
+	PrintWriter w = response.getWriter();
+	w.write("Invalid parameters supplied! Need key (k=), interface name (i=) and language (l=). If you specified a method call, it must be on the list of supported method calls, and you must specify a command (c=) and parameters (p=).");
+	w.close();
+	} catch (Exception ex) { /* Should log here */ }
+	
+}
+	
+}
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java	(revision 24007)
@@ -19,4 +19,6 @@
 import org.apache.log4j.*;
 
+// Apache Commons
+import org.apache.commons.lang3.*;
 
 /** a servlet to serve the greenstone library - we are using servlets instead
@@ -43,4 +45,7 @@
    * otherwise DEFAULT_LANG is used*/
   protected String default_lang= null;
+  
+  /** Whether or not client-side XSLT support should be exposed */
+  protected boolean supports_client_xslt = false;
 
   /** The default default - used if a default lang is not specified
@@ -87,6 +92,11 @@
     String gsdl3_home = config.getInitParameter(GSConstants.GSDL3_HOME);
     String interface_name = config.getInitParameter(GSConstants.INTERFACE_NAME);
+	
+	String allowXslt = (String)config.getInitParameter(GSConstants.ALLOW_CLIENT_SIDE_XSLT);
+	supports_client_xslt = allowXslt != null && allowXslt.equals("true");
+	
     this.default_lang = config.getInitParameter(GSConstants.DEFAULT_LANG);
     String sess_expire = config.getInitParameter(GSXML.SESSION_EXPIRATION);
+	
     if (sess_expire != null && !sess_expire.equals("")) {
       this.session_expiration = Integer.parseInt(sess_expire);
@@ -125,5 +135,7 @@
     
     config_params.put(GSConstants.LIBRARY_NAME, library_name);
-    config_params.put(GSConstants.INTERFACE_NAME, interface_name);
+    config_params.put(GSConstants.INTERFACE_NAME, interface_name);	
+	config_params.put(GSConstants.ALLOW_CLIENT_SIDE_XSLT, supports_client_xslt);
+	
     if (site_name != null) {
       config_params.put(GSConstants.SITE_NAME, site_name);
@@ -281,9 +293,12 @@
     String query_string = request.getQueryString();
     if (query_string!=null){
-      String[] query_arr = query_string.split("&");
+      String[] query_arr = StringUtils.split(query_string, "&");
       boolean redirect = false;
       String href = null;
       String rl = null;
+      String[] nameval = new String[2]; // Reuse it for memory efficiency purposes	
+
       for (int i=0;i<query_arr.length;i++){
+
         if (query_arr[i].startsWith("el=")){
           if (query_arr[i].substring(query_arr[i].indexOf("=")+1,query_arr[i].length()).equals("direct")){
@@ -292,12 +307,13 @@
         }else if(query_arr[i].startsWith("href=")){
           href = query_arr[i].substring(query_arr[i].indexOf("=")+1,query_arr[i].length());
-          href = href.replaceAll("%2f", "/");
-          href = href.replaceAll("%7e", "~");
-          href = href.replaceAll("%3f", "?");
-          href = href.replaceAll("%3A", "\\:");
+          href = StringUtils.replace(href, "%2f", "/");
+          href = StringUtils.replace(href, "%7e", "~");
+          href = StringUtils.replace(href, "%3f", "?");
+          href = StringUtils.replace(href, "%3A", "\\:");
         }else if(query_arr[i].startsWith("rl=")){
           rl = query_arr[i].substring(query_arr[i].indexOf("=")+1,query_arr[i].length());
         }
       }
+
       //if query_string contains "el=", the web page will be redirected to the external URl, otherwise a greenstone page with an external URL will be displayed
       //"rl=0" this is an external link
@@ -308,6 +324,6 @@
       }
     }
+	
     // Nested Diagnostic Configurator to identify the client for
-    
     HttpSession session = request.getSession (true);
     session.setMaxInactiveInterval(session_expiration);
@@ -338,9 +354,32 @@
       output = "html"; // uses html by default
     }
-    
+	
+	// If server output, force a switch to traditional interface
+	//output = (output.equals("server")) ? "html" : output;
+	
+	// Force change the output mode if client-side XSLT is supported - server vs. client
+	// BUT only if the library allows client-side transforms	
+	if(supports_client_xslt) {
+		// MUST be done before the xml_message is built
+		Cookie[] cookies = request.getCookies();
+		Cookie xsltCookie = null;
+		
+		// The client has cookies enabled and a value set - use it!
+		if(cookies != null) {
+			for(Cookie c : cookies) {
+				if(c.getName().equals("supportsXSLT")) {
+					xsltCookie = c;
+					break;
+				}
+			}
+			output = (xsltCookie != null && xsltCookie.getValue().equals("true") && output.equals("html")) ? "xsltclient" : output;
+		}
+	}
+	
     // the request to the receptionist
     Element xml_message = this.doc.createElement (GSXML.MESSAGE_ELEM);
     Element xml_request = GSXML.createBasicRequest (this.doc, GSXML.REQUEST_TYPE_PAGE, "", lang, uid);
     xml_request.setAttribute (GSXML.OUTPUT_ATT, output);
+    
     xml_message.appendChild (xml_request);
     
@@ -464,5 +503,5 @@
           && !name.equals (GSParams.LANGUAGE) 
           && !name.equals (GSParams.OUTPUT)) {// we have already dealt with these
-
+		  
           String value="";
           String [] values = request.getParameterValues (name);
@@ -509,5 +548,5 @@
 
           // ugly hack to undo : escaping
-          value = value.replaceAll ("%3A", "\\:");
+          value = StringUtils.replace(value, "%3A", "\\:");
           param.setAttribute (GSXML.VALUE_ATT,value);
           xml_param_list.appendChild (param);
@@ -516,5 +555,5 @@
     }
       
-    if (!output.equals ("html")) {
+    if (!output.equals("html") && !output.equals("server") && !output.equals("xsltclient")) {
       response.setContentType ("text/xml"); // for now use text
     }
@@ -584,5 +623,8 @@
 		// get all the <a> elements
 		NodeList hrefs = data.getElementsByTagName("a");
-		for (int i=0; hrefs!=null && i<hrefs.getLength(); i++) {
+		// Instead of calculating each iteration...
+		int hrefscount = hrefs.getLength();
+
+		for (int i=0; hrefs!=null && i < hrefscount; i++) {
 		  Element a = (Element)hrefs.item(i);
 		  // ugly hack to get rid of : in the args - interferes with session handling
@@ -590,7 +632,16 @@
 		  if (!href.equals("")) {
 		    if (href.indexOf("?")!=-1) {
-		      String[] parts = href.split("\\?", -1);
-		      parts[1]=parts[1].replaceAll(":", "%3A");
-		      href = parts[0]+"?"+parts[1];
+		      String[] parts = StringUtils.split(href, "\\?", -1);
+			  if (parts.length == 1)
+			  {
+				parts[0] = StringUtils.replace(parts[0], ":", "%3A");
+				href = "?"+parts[0];
+			  }
+			  else
+			  {
+				parts[1] = StringUtils.replace(parts[1], ":", "%3A");
+				href = parts[0]+"?"+parts[1];
+			  }
+		      
 		    }
 		    a.setAttribute("href", response.encodeURL(href));
@@ -600,5 +651,6 @@
 		// now find any submit bits - get all the <form> elements
 		NodeList forms = data.getElementsByTagName("form");
-		for (int i=0; forms!=null && i<forms.getLength(); i++) {
+		int formscount = forms.getLength();
+		for (int i=0; forms!=null && i < formscount; i++) {
 		  Element form = (Element)forms.item(i);
 		  form.setAttribute("action", response.encodeURL(form.getAttribute("action")));
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/OAIServer.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/OAIServer.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/OAIServer.java	(revision 24007)
@@ -29,4 +29,7 @@
 import java.util.Enumeration;
 import java.util.HashSet;
+import java.util.Iterator;
+import java.util.Map;
+import java.util.Map.Entry;
 import java.io.File;
 
@@ -78,4 +81,8 @@
   protected String oai_stylesheet = "interfaces/oai/oai2.xsl";
 
+    // there is no getQueryString() method in the HttpServletRequest returned from doPost, 
+    // since that is actually of type apache RequestFacade, and doesn't define such a method
+    protected String queryString = null;
+
   static Logger logger = Logger.getLogger(org.greenstone.gsdl3.OAIServer.class.getName());
   
@@ -223,9 +230,11 @@
     String usageInfo = "";
     
+    String query = (queryString == null) ? request.getQueryString() : queryString;
+
     //logged info = general-info + session-info
     usageInfo =
       request.getContextPath()+" "+ //session id
       request.getServletPath()+" "+ //serlvet
-      "["+request.getQueryString()+"]" +" "+ //the query string
+      "["+query+"]" +" "+ //the query string
       "["+usageInfo.trim()+"]" +" "+ // params stored in a session
       request.getRemoteAddr()+" "+   //remote address
@@ -256,4 +265,5 @@
     return query.substring(verb_start_index, verb_end_index);
   }
+
   public void doGet(HttpServletRequest request, HttpServletResponse response)
     throws ServletException, IOException {
@@ -276,5 +286,8 @@
     //For example, puka.cs.waikato.ac.nz vs www.greenstone.org
     //String base_url = request.getRequestURL().toString();
-    String query = request.getQueryString();
+    // if called by doPost (if this was originally a POST request), var queryString would have been set
+    String query = (queryString == null) ? request.getQueryString() : queryString;
+    queryString = null; // reset member variable, else no doGet will work as long as the server remains running
+
     String[] pairs = (query==null)? null : query.split("&");//split into key/value pairs
     String verb = getVerb(query);
@@ -377,7 +390,34 @@
     } 
   }
+
+  // For OAI version 2.0, validation tests indicated that POST needs to be supported. Some
+  // modification was required in order to ensure that the request is passed intact to doGet()
   public void doPost(HttpServletRequest request,
     HttpServletResponse response)
     throws ServletException, IOException {
+
+      // the post method returns a wrapper of type RequestFacade by apache and there
+      // is no getQueryString() method defined for it. Therefore, need to work this out
+      // manually before calling doGet(request, response) so that doGet can work as before.
+      
+      queryString = "";
+      Iterator parameter_entries = request.getParameterMap().entrySet().iterator();
+      while(parameter_entries.hasNext()) {	  
+	  Map.Entry param_entry = (Map.Entry)parameter_entries.next();
+	  String[] paramVals = (String[]) param_entry.getValue();
+	  if(paramVals != null) {
+	      if(paramVals.length > 0) {
+		  logger.error("POST request received: " + param_entry.getKey() + " - " + paramVals[0]);
+		  queryString = queryString + "&" + param_entry.getKey() + "=" + paramVals[0];
+	      }
+	  }	  
+      }
+      if(queryString.length() > 0) {
+	  queryString = queryString.substring(1);
+	  //queryString = OAIXML.oaiEncode(queryString);
+      }
+      if(queryString.equals("")) {
+	  queryString = null;
+      }
     doGet(request,response);    
   }
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java	(revision 24007)
@@ -97,10 +97,11 @@
 
     try {
-            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
-            DocumentBuilder builder = factory.newDocumentBuilder();
+            //DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
+            //DocumentBuilder builder = factory.newDocumentBuilder();
             //String input = "<html><head><title></title></head><body>" + format_string + "</body></html>";
-            String input = format_string;
-            InputSource is = new InputSource( new StringReader( input ) );
-            Document d = (Document) builder.parse( is );
+            //String input = format_string;
+            //InputSource is = new InputSource( new StringReader( input ) );
+            //Document d = (Document) builder.parse( is );
+            Document d = this.converter.getDOM(format_string); //(Document) builder.parse( is );
             //Node n1 = d.getFirstChild();            
             //Document d2 = (Document) this.doc.importNode(e, true);
@@ -111,5 +112,7 @@
             XMLTransformer transformer = new XMLTransformer();
             // HOW DO I DO THIS PROPERLY?
-            Document style_doc = this.converter.getDOM(new File("/home/sam/greenstone3/web/interfaces/oran/transform/formatString.xsl"), "UTF-8");
+            //String style = stylesheetFile(String gsdl3_home, String site_name, String collection, String interface_name, ArrayList base_interfaces, String filename);
+            //Document style_doc = this.converter.getDOM(new File(style), "UTF-8"); //"/home/sam/greenstone3/web/interfaces/oran/transform/formatString.xsl"), "UTF-8");  /*************************/
+            Document style_doc = this.converter.getDOM(new File("/home/sam/greenstone3/web/interfaces/oran/transform/formatString.xsl"), "UTF-8");  /*************************/
 
             if(style_doc == null)
@@ -117,7 +120,7 @@
 
             // not sure what to do here - some code from Transforming Receptionist
-            String transformed = transformer.transformToString(style_doc, d);
+            //String transformed = transformer.transformToString(style_doc, d);
             logger.error("About to transform");
-            //Node transformed = (Node) transformer.transform(style_doc, d);  // Failing org.w3c.dom.DOMException: HIERARCHY_REQUEST_ERR: An attempt was made to insert a node where it is not permitted. ; SystemID: file:///home/sam/greenstone3/packages/tomcat/bin/dummy.xsl
+            Node transformed = (Node) transformer.transform(style_doc, d);  // Failing org.w3c.dom.DOMException: HIERARCHY_REQUEST_ERR: An attempt was made to insert a node where it is not permitted. ; SystemID: file:///home/sam/greenstone3/packages/tomcat/bin/dummy.xsl
 
             logger.error("Transform successful?");
@@ -125,4 +128,8 @@
             if(transformed==null)  // not null
                 logger.error("TRANSFORMED IS NULL");
+
+            if(transformed.getNodeType() == Node.DOCUMENT_NODE)
+                transformed = ((Document)transformed).getDocumentElement(); 
+            logger.error("Node type: "+transformed.getNodeType());
 
             //logger.error("begin import"); 
@@ -134,6 +141,6 @@
  
             Element format = this.doc.createElement(GSXML.FORMAT_STRING_ELEM);
-            GSXML.setNodeText(format, transformed);
-            //format.appendChild(transformed);
+            //GSXML.setNodeText(format, transformed);
+            format.appendChild(this.doc.importNode(transformed,true));
             //format.setNodeValue(transformed);
             mr_request.appendChild(format); 
Index: main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/collection/Collection.java
===================================================================
--- main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/collection/Collection.java	(revision 23632)
+++ main/branches/64_bit_Greenstone/greenstone3/src/java/org/greenstone/gsdl3/collection/Collection.java	(revision 24007)
@@ -44,4 +44,7 @@
 import org.apache.log4j.*;
 
+// Apache Commons
+import org.apache.commons.lang3.*;
+
 /**
  * Represents a collection in Greenstone. A collection is an extension of
@@ -65,5 +68,8 @@
     /** time when this collection was built */
     protected long lastmodified = 0;
-    
+    /** earliestDatestamp of this collection. Necessary for OAI */
+    protected long earliestDatestamp = 0;
+
+
     /** An element containing the serviceRackList element of buildConfig.xml, used to determine whether it contains
      *  the OAIPMH serviceRack 
@@ -130,8 +136,14 @@
 	return is_public;
     }
-    //used by the OAIReceptionist to find out the earliest datestamp amongst all oai collections in the repository
+    // Not used anymore by the OAIReceptionist to find out the earliest datestamp 
+    // amongst all oai collections in the repository. May be useful generally.
     public long getLastmodified() {
       return lastmodified;
     }
+    //used by the OAIReceptionist to find out the earliest datestamp amongst all oai collections in the repository
+    public long getEarliestDatestamp() {
+	return earliestDatestamp;
+    }
+
     /** whether the service_map in ServiceCluster.java contains the service 'OAIPMH'
      *  11/06/2007 xiao
@@ -176,5 +188,5 @@
 	    build_config_elem = build_config_doc.getDocumentElement();
 	}
-  
+
 	lastmodified = build_config_file.lastModified();
   
@@ -211,8 +223,8 @@
         addPlugins(plugin_list);
         if (plugin_list != null){
-          Element plugin_elem = (Element)GSXML.getNamedElement(plugin_list, GSXML.PLUGIN_ELEM, GSXML.NAME_ATT, "HTMLPlug");
+          Element plugin_elem = (Element)GSXML.getNamedElement(plugin_list, GSXML.PLUGIN_ELEM, GSXML.NAME_ATT, "HTMLPlugin");
           if (plugin_elem != null) {
             //get the option
-            Element option_elem = (Element)GSXML.getNamedElement(plugin_elem, GSXML.PARAM_OPTION_ELEM, GSXML.NAME_ATT, "-tidy_html");
+            Element option_elem = (Element)GSXML.getNamedElement(plugin_elem, GSXML.PARAM_OPTION_ELEM, GSXML.NAME_ATT, "-use_realistic_book");
             if (option_elem != null) {
               useBook = true;
@@ -261,5 +273,30 @@
       } else {
 	has_oai = true;
+	
+	// extract earliestDatestamp from the buildconfig.xml for OAI
+	Element metadata_list = (Element)GSXML.getChildByTagName(build_config_xml, GSXML.METADATA_ELEM+GSXML.LIST_MODIFIER);
+
+	if(metadata_list != null) {
+	    NodeList children = metadata_list.getElementsByTagName(GSXML.METADATA_ELEM); 
+	           // can't do getChildNodes(), because whitespace, such as newlines, creates Text nodes
+	    for (int i = 0; i < children.getLength(); i++) {
+		Element metadata = (Element)children.item(i);
+		if(metadata.getAttribute(GSXML.NAME_ATT).equals(OAIXML.EARLIEST_DATESTAMP)) {
+		    String earliestDatestampStr = GSXML.getValue(metadata);
+		    if(!earliestDatestampStr.equals("")) {
+			earliestDatestamp = Long.parseLong(earliestDatestampStr);
+		    }
+		    break; // found a metadata element with name=earliestDatestamp in buildconfig
+		}
+	    }
+	}
+	
+	// If at the end of this, there is no value for earliestDatestamp, print out a warning
+	logger.warn("No earliestDatestamp in buildConfig.xml for collection: " + this.cluster_name + ". Defaulting to 0.");
+
       }
+    } else { // no list of services (no ServiceRackList), so no oai_service_rack either
+	// explicitly set has_oai to false here, since it's initialised to true by default
+	has_oai = false;
     }
     return true;
@@ -275,6 +312,6 @@
 		Element d = (Element) displaynodes.item(k);
 		String text = GSXML.getNodeText(d);
-		text = text.replaceAll("_httpsite_", http_site);
-		text = text.replaceAll("_httpcollection_", http_collection);
+		text = StringUtils.replace(text, "_httpsite_", http_site);
+		text = StringUtils.replace(text, "_httpcollection_", http_collection);
 		GSXML.setNodeText(d, text);
 	    }
@@ -338,6 +375,6 @@
 
         Element format_element = (Element) GSXML.getChildByTagName(request, GSXML.FORMAT_STRING_ELEM);
-        String format_string = GSXML.getNodeText(format_element);
-        //Element format_statement = (Element) format_element.getFirstChild();
+        //String format_string = GSXML.getNodeText(format_element);
+        Element format_statement = (Element) format_element.getFirstChild();
 
         //logger.error("Format string: " + format_string);
@@ -394,5 +431,5 @@
 
                 // Write format statement
-                //String format_string = GSXML.xmlNodeToString(format_statement);
+                String format_string = this.converter.getString(format_statement); //GSXML.xmlNodeToString(format_statement);
                 writer = new BufferedWriter(new FileWriter(format_statement_filename));
                 writer.write(format_string);
@@ -416,13 +453,13 @@
 
                 // Convert format string to a document
-                DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
-                DocumentBuilder builder = factory.newDocumentBuilder();
+                //DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
+                //DocumentBuilder builder = factory.newDocumentBuilder();
                 //String input = "<html><head><title></title></head><body>" + format_string + "</body></html>";
-                String input = format_string.substring(0,format_string.length()-1)+"</xml>";
-                logger.error(input);
-                InputSource is = new InputSource( new StringReader( input ) );
-                logger.error("About to parse format string");
-                Document format_statement = (Document) builder.parse( is );
-                logger.error("Done parsing format string");
+                //String input = format_string.substring(0,format_string.length()-1)+"</xml>";
+                //logger.error(input);
+                //InputSource is = new InputSource( new StringReader( input ) );
+                //logger.error("About to parse format string");
+                //Document format_statement = (Document) builder.parse( is );
+                //logger.error("Done parsing format string");
 
                 // open collectionConfig.xml and read in to w3 Document
@@ -488,11 +525,16 @@
 
                 // append new but we have a string!
-                GSXML.setNodeText(elem, format_string);
-
-                //current_node_list = format_statement.getChildNodes();
-                //for(k=0; k<current_node_list.getLength(); k++)
-                //{
-                //    current_node = elem.appendChild(current_node_list.item(k));
-                //}
+                //GSXML.setNodeText(elem, "THIS IS A TEST");
+                //GSXML.setNodeText(elem, format_string);
+
+                current_node_list = format_statement.getChildNodes();
+                for(k=0; k<current_node_list.getLength(); k++)
+                {
+                    //if(transformed.getNodeType() == Node.DOCUMENT_NODE)
+                //transformed = ((Document)transformed).getDocumentElement();
+                    logger.error("Node type: "+current_node_list.item(k).getNodeType());
+                    if(current_node_list.item(k).getNodeType() != Node.PROCESSING_INSTRUCTION_NODE)
+                        current_node = elem.appendChild(this.doc.importNode(current_node_list.item(k),true));
+                }
 
                 //String text = GSXML.getNodeText(elem);
@@ -503,5 +545,5 @@
 
                 // Now convert config document to string for writing to file
-                String new_config = GSXML.xmlNodeToString(config);
+                String new_config = this.converter.getString(config);
     
                 // Write to file (not original! for now)
